#include "../include/config.h"
#include "../include/struct.h"
#include "../include/common.h"
#include "../include/sys.h"
#include "../include/numeric.h"
#include "../include/msg.h"
#include "../include/channel.h"
#include "../include/userload.h"
#include <stdio.h>
#include "../include/h.h"
#include "../include/auslink.h"

extern	char	translate_esc(char *, char *);

void 
trailing_blanks(char *str)
{
    int     i;

    for (i = strlen(str); i > 0; i--)
    {
	if (isspace(str[i - 1]))
	    str[i - 1] = '\0';
	else
	    return;
    }
}

void 
strip_newline(char *string)
{
    char   *ptr;

    if (ptr = (char *) strchr(string, '\n'))
	*ptr = '\0';
    if (ptr = (char *) strchr(string, '\r'))
	*ptr = '\0';
}

char 
strlower(char *buf)
{
    int     i = 0;

    while (buf[i] != '\0')
    {
	buf[i] = tolower(buf[i]);
	i++;
    }
    buf[i] = '\0';
}

char   *
thedate()
{
    time_t  timer;

    time(&timer);
    strcpy(strbuff, ctime(&timer));
    strip_newline(strbuff);
    return strbuff;
}


/* Allow uline clients to do modes */
int 
AUSservices(cptr, sptr)
    aClient *cptr, *sptr;
{
    aConfItem *aconf;

    if (find_conf_host(cptr->confs, sptr->name, CONF_UWORLD)
    	|| (sptr->user && find_conf_host(cptr->confs,
    	sptr->user->server, CONF_UWORLD)))
	    sptr->flags |= FLAGS_ULINE;
}

/* Send logo :) */
/*
int 
SetClient(sptr)
    aClient *sptr;
{
    SetUser(sptr);
    if (MyConnect(sptr))
    {
	send(sptr->fd, AUS1, 52, 0);
	send(sptr->fd, AUS2, 73, 0);
	send(sptr->fd, AUS3, 73, 0);
 	send(sptr->fd, AUS4, 74, 0);
	send(sptr->fd, AUS5, 72, 0);
	send(sptr->fd, AUS6, 44, 0);
	send(sptr->fd, AUS7, 14, 0);
    }
}
*/

/* m_gnotice  (Russell) sort of like wallop, but only to +g clients on
** this server.		-- Thanks to DALnet IRCD Distribution
**      parv[0] = sender prefix
**      parv[1] = message text
*/
int 
m_gnotice(cptr, sptr, parc, parv)
    aClient *cptr, *sptr;
    int     parc;
    char   *parv[];
{
    char   *message, *pv[4];

    message = parc > 1 ? parv[1] : NULL;

    if (BadPtr(message))
    {
	sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS),
		   me.name, parv[0], "GNOTICE");
	return 0;
    }
    if (!IsServer(sptr) && MyConnect(sptr))
    {
        sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
        return 0;
    }
    sendto_serv_butone(IsServer(cptr) ? cptr : NULL, ":%s GNOTICE :%s",
		       parv[0], message);
    sendto_failops("from %s: %s", parv[0], message);
    return 0;
}

/*
** m_globops (write to opers who are +g currently online)	-- DALnet Distrub
**      parv[0] = sender prefix
**      parv[1] = message text
*/
int 
m_globops(cptr, sptr, parc, parv)
    aClient *cptr, *sptr;
    int     parc;
    char   *parv[];
{
    char   *message, *pv[4];

    message = parc > 1 ? parv[1] : NULL;

    if (BadPtr(message))
    {
	sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS),
		   me.name, parv[0], "GLOBOPS");
	return 0;
    }
    if (!IsServer(sptr) && MyConnect(sptr) && !IsAnOper(cptr))
    {
        sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
        return 0;
    }
    sendto_serv_butone(IsServer(cptr) ? cptr : NULL,
		       ":%s GLOBOPS :%s", parv[0], message);
    sendto_failops_whoare_opers("from %s: %s", parv[0], message);
    return 0;
}

/* m_goper  (Russell) sort of like wallop, but only to ALL +o clients on
** every server.	--DALnet Distrib
**      parv[0] = sender prefix
**      parv[1] = message text
*/
int 
m_goper(cptr, sptr, parc, parv)
    aClient *cptr, *sptr;
    int     parc;
    char   *parv[];
{
    char   *message, *pv[4];

    message = parc > 1 ? parv[1] : NULL;

    if (BadPtr(message))
    {
	sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS),
		   me.name, parv[0], "GLOBAL");
	return 0;
    }
/*    if (!IsServer(sptr) && MyConnect(sptr) && !IsAnOper(sptr)) */
    if (!IsServer(sptr) && !AUSservices(cptr, sptr))
    {
        sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
        return 0;
    }
    sendto_serv_butone(IsServer(cptr) ? cptr : NULL, ":%s GOPER :%s",
		       parv[0], message);
    sendto_opers("from %s: %s", parv[0], message);
    return 0;
}

/*
 * m_end_of_burst  - Added Xorath 6-14-96, rewritten by Run 24-7-96
 *               - and fixed by record and Kev 8/1/96
 * This the last message in a net.burst.
 * It clears a flag for the server sending the burst.
 *
 * parv[0] - sender prefix
 */
m_end_of_burst(cptr, sptr, parc, parv)
    aClient *cptr, *sptr;
    int     parc;
    char   *parv[];
{
    if (!IsServer(sptr))
	return 0;

    sendto_ops("Completed receiving Burst Data from %s.", sptr->name);
    sendto_ops_butone(sptr,":%s END_OF_BURST", parv[0]);

    return 0;
}

/* m_helpme		-- Krelf. Helpers wallops
** parv[0] = sender prefix
** parv[1] = message text
*/      
int
m_helpme(cptr, sptr, parc, parv)
    aClient *cptr, *sptr;
    int     parc;
    char   *parv[];
{   
    char   *message, *pv[4];
    
    message = parc > 1 ? parv[1] : NULL; 
    
    if (BadPtr(message))  
    {
        sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS),
                   me.name, parv[0], "HELPME");
        return 0;
    }
    if (!IsServer(sptr) && !AUSservices(cptr, sptr) && !IsHelper(sptr) && !IsAnOper(sptr))
    {
	sendto_one(sptr, err_str(ERR_NOPERMFORHOST), me.name, parv[0]);
	return 0;
    }
    sendto_serv_butone(IsServer(cptr) ? cptr : NULL, ":%s HELPERS :%s",
                       parv[0], message);
    sendto_helpers("from %s: %s", parv[0], message);
    return 0;
}   


/* m_helper		-- Krelf Give person umode +h
** parv[0] = sender prefix
** parv[1] = username to change mode for
** parv[2] = who originally did the command
*/
int 
m_helper(cptr, sptr, parc, parv, acptr)
    aClient *cptr, *sptr, *acptr;
    int     parc;
    char   *parv[];
{
    Reg1 aClient *from;

    if (parc < 2)
    {
	sendto_one(sptr, err_str(ERR_NEEDMOREPARAMS),
		   me.name, parv[0], "HELPER");
	return 0;
    }

    if (IsAnOper(cptr) || AUSservices(cptr, sptr) || IsServer(sptr))
    {
	if (!(from = find_client(parv[1], (aClient *) NULL)))
	{
	    sendto_one(sptr, err_str(ERR_NOSUCHNICK),
		       me.name, parv[0], parv[1]);
	    return 0;
	}
        else if (IsAnOper(sptr) || IsHelper(sptr))
	{
        	sendto_one(sptr, err_str(ERR_ISANOPER), me.name, parv[0], parv[1]);
	}
	else
	{
		from->flags |= FLAGS_HELPER;
		sendto_serv_butone(sptr, ":%s HELPER %s", me.name, parv[1]);
		if (MyConnect(from)) {
		    sendto_one(from, rpl_str(RPL_YOURHELPER), me.name, parv[1]);
        	    sendto_one(from, ":%s MODE %s :+h", parv[1], parv[1]);
	        }
	}
    }
    else
    {
	sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
	return 0;
    }
}

